﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private clv1 As CustomListView
	Private lsttitles As List
	Private lstimages As List
	Private iv1 As ImageView
	Private lbltitle As Label
	Private ivphoto As ImageView
	Private photodialog As B4XDialog
End Sub

Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"clvtest")
	lsttitles = Array As String("dbdialog","datedialog","caldialog")
	lstimages = Array As String("dialogs_001.png","dialogs_002.png","dialogs_003.png")
	photodialog.Initialize(Root)
	photodialog.PutAtTop = True
	photodialog.BackgroundColor = Colors.White
End Sub
Private Sub B4XPage_Appear
	fill_clv1
End Sub

Private Sub fill_clv1
	clv1.Clear
	For i = 0 To lsttitles.Size -1
		Dim title As String = lsttitles.Get(i)
		Dim imgfile As String = lstimages.Get(i)
		' panel containing lbltitle and iv1 added to the custom listview in the next line
		Dim pnl As Panel = clv1_item(title,imgfile,i)
		' the value of the clv1 item is the image filename to be used in the photodialog
		clv1.Add(pnl,imgfile)
	Next
End Sub
Private Sub clv1_item(tit As String, imgf As String, cnt As Int) As Panel
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0dip, 0dip, clv1.AsView.Width,100dip)
	p.LoadLayout("clv1_item_layout")  
	' when the empty space behind lbltitle is clicked the photodialog is shown
	lbltitle.Text = tit
	lbltitle.Tag = cnt		' when the lbltitle is clicked the index from the clv1 is shown
	iv1.Bitmap = LoadBitmap(File.DirAssets,imgf)
	iv1.Tag = imgf			' when the iv1 is clicked the filename from the iv1 is shown and the photodialog is shown
	Return p
End Sub
Private Sub clv1_ItemClick (Index As Int, Value As Object)
	' the argument for the photodialog is the value of the custom listview item that was clicked!
	show_photodialog(Value)
End Sub
Private Sub titles_Click		' in the designer lbltitle Event Name is set to titles
	Dim lbl As Label = Sender
	' the lbltitle tag is set to the custom listview item index
	xui.MsgboxAsync("Title number " & lbl.tag,"Title clicked")
End Sub

Private Sub images_Click		' in the designer iv1 Event Name is set to images
	Dim iv As ImageView = Sender
	xui.MsgboxAsync("Image filename " & iv.tag,"Image clicked")
	' the argument for the photodialog is an imageview tag!
	show_photodialog(iv.Tag)
End Sub
private Sub show_photodialog(imgfilename As String)
	Dim devwidth As Int = GetDeviceLayoutValues.Width
	Dim devheight As Int = GetDeviceLayoutValues.height
	Dim pnl As B4XView = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0dip, 0dip, 0dip,340dip, 500dip)
	pnl.LoadLayout("photodialog_layout")
	' in the designer set the bottom edge distance from ivphoto to 5dip 
	' this way the button from the dialog is not partially covered
	
	' the imageview bitmap is resized using the LoadBitmapResize function
	ivphoto.Bitmap = LoadBitmapResize(File.DirAssets,imgfilename,devwidth,devheight,True)
	
	' below is a not so elegant way of doing the same thing
	'ivphoto.Bitmap = LoadBitmap(File.DirAssets,imgfilename)	' not resized yet
	'pnl.RemoveAllViews											' ivphoto already had a parent 
	'pnl.AddView(ivphoto,0,0,340dip,490dip)						' resize by adding the view again
	
	Dim rsub1 As ResumableSub =  photodialog.ShowCustom(pnl, "OK", "", "")
	Wait For (rsub1) Complete (Result As Int)
	If Result = xui.dialogResponse_Positive Then
		' no action to be taken 
	End If
End Sub
